--[[
	All rights are reserved unless explicitly stated below. The "license holder" is Minorin @ EU-Pozzo dell'Eternità (hideki87@gmail.com)
	
	# You may use this addon in accordance with all applicable terms set by Blizzard Entertainment for addon usage
	# You may modify this addon for personal use
	# You may NOT redistribute this addon in any way or form
--]]


-- register with Ace Libraries
MercenaryBuddy = LibStub("AceAddon-3.0"):NewAddon("Mercenary Buddy", "AceConsole-3.0", "AceEvent-3.0", "AceBucket-3.0")

local MB = MercenaryBuddy

local L = LibStub("AceLocale-3.0"):GetLocale("Mercenary Buddy")

local WasMercenary = false

local AddonVersion = GetAddOnMetadata("MercenaryBuddy", "Version")

-- Options

local defaults = {
    profile = {
        showInfoUpdate = true,
		premacro = {
			[1] = "#showtooltip $racial("..L["Racial"]..")\n/cast $racial("..L["Racial"]..")",
			[2] = "#showtooltip $racial("..L["Racial"]..")\n/cast $racial("..L["Racial"]..")",
			[3] = "#showtooltip $racial("..L["Racial"]..")\n/cast $racial("..L["Racial"]..")",
		},
		premacrom = {
			[1] = "#showtooltip $racial("..L["Racial"]..")\n/cast $racial("..L["Racial"]..")",
			[2] = "#showtooltip $racial("..L["Racial"]..")\n/cast $racial("..L["Racial"]..")",
			[3] = "#showtooltip $racial("..L["Racial"]..")\n/cast $racial("..L["Racial"]..")",
		},
		premacroc = {
			[1] = true,
			[2] = true,
			[3] = true,
		},
		racialorder = {
			["Worgen"] = {
				[1] = L["Darkflight"],
				[2] = L["Two Forms"],
				[3] = L["Running Wild"],
			},
			["Forsaken"] = {
				[1] = L["Will of the Forsaken"],
				[2] = L["Cannibalize"],
			},
			["Goblin"] = {
				[1] = L["Rocket Jump"],
				[2] = L["Rocket Barrage"],
				[3] = L["Pack Hobgoblin"],
			},
		},
    },
}

local listracial = {
	["Worgen"] = {
		[1] = L["Darkflight"],
		[2] = L["Running Wild"],
		[3] = L["Two Forms"],
	},
	["Forsaken"] = {
		[1] = L["Cannibalize"],
		[2] = L["Will of the Forsaken"],
	},
	["Goblin"] = {
		[1] = L["Pack Hobgoblin"],
		[2] = L["Rocket Jump"],
		[3] = L["Rocket Barrage"],
	},
}

local options = {
    type = "group",
	inline = true,
	childGroups = "tree",
    args = {
		general = {
			type = "group",
			name = L["General Options"],
			order = 1,
			args = {
				description = {
					type = "description",
					name = L["Usage"],
					fontSize = "medium",
					order = 0,
				},
				break1 = {
					type = "header",
					name = L["Macro Manage"],
					order = 1,
				},
				mkmacro = {
					type = "execute",
					name = L["Create Macros"],
					order = 2,
					--width = "double",
					func = function() MB:InitMacro() end,
				},
				rmmacro = {
					type = "execute",
					name = L["Delete Macros"],
					order = 3,
					--width = "double",
					func = function() MB:DeleteMacro() end,
				},
				rstnacro= {
					type = "execute",
					name = L["Reset Macros"],
					order = 4,
					width = "double",
					func = function() MB:ResetCustomMacro() end,
				},
				break2 = {
					type = "header",
					name = L["Chat Messages"],
					order = 5,
				},--]]
				showInfoUpdate = {
					type = "toggle",
					name = L["Display racials update"],
					order = 6,
					width = "full",
					get = function(info) return MB.db.profile.showInfoUpdate end,
					set = function(info, value) MB.db.profile.showInfoUpdate = value end,
				},
			},
		},
		custommacro = {
			type = "group",
			name = L["Customize Macros"],
			order = 2,
			--childGroups = "tab",
			args = { 
				description = {
					type = "description",
					name = L["Usage Custom Macro"],
					order = 0,
				},
				macro1 = {
					type = "input",
					name = "MercenaryBuddy1",
					desc = "",
					--order = 7,
					width = "full",
					multiline = 7,
					get = function(info) return MB.db.profile.premacro[1] end,
					set = function(info, value) 
						MB.db.profile.premacro[1] = value
						MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false) end,
				},
				macro2 = {
					type = "input",
					name = "MercenaryBuddy2",
					--order = 7,
					width = "full",
					multiline = 7,
					get = function(info) return MB.db.profile.premacro[2] end,
					set = function(info, value) 
						MB.db.profile.premacro[2] = value
						MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false) end,
				},
				macro3 = {
					type = "input",
					name = "MercenaryBuddy3",
					--order = 7,
					width = "full",
					multiline = 7,
					get = function(info) return MB.db.profile.premacro[3] end,
					set = function(info, value) 
						MB.db.profile.premacro[3] = value
						MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false) end,
				},
				mercenary = {
					type = "group",
					name = L["Mercenary only"],
					order = 2,
					args = { 
						description = {
							type = "description",
							name = L["Usage Mercenary only"],
							order = 0,
						},
						macroc1 = {
							name = L["Customize first macro when mercenary"],
							--desc = "Enables / disables the addon",
							type = "toggle",
							width = "full",
							order = 1,
							get = function(info) return not MB.db.profile.premacroc[1] end,
							set = function(info, val) MB.db.profile.premacroc[1] = not MB.db.profile.premacroc[1] MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false)	end,
						},
						macrom1 = {
							type = "input",
							name = "MercenaryBuddy1",
							desc = "",
							disabled = function() return MB.db.profile.premacroc[1] end,
							order = 2,
							width = "full",
							multiline = 6,
							get = function(info) return MB.db.profile.premacrom[1] end,
							set = function(info, value) MB.db.profile.premacrom[1] = value MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false) end,
						},
						macroc2 = {
							name = L["Customize second macro when mercenary"],
							--desc = "Enables / disables the addon",
							type = "toggle",
							width = "full",
							order = 3,
							get = function(info) return not MB.db.profile.premacroc[2] end,
							set = function(info, val) MB.db.profile.premacroc[2] = not MB.db.profile.premacroc[2] MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false)	end,
						},
						macrom2 = {
							type = "input",
							name = "MercenaryBuddy2",
							disabled = function() return MB.db.profile.premacroc[2] end,
							order = 4,
							width = "full",
							multiline = 6,
							get = function(info) return MB.db.profile.premacrom[2] end,
							set = function(info, value) MB.db.profile.premacrom[2] = value MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false) end,
						},
						macroc3 = {
							name = L["Customize third macro when mercenary"],
							--desc = "Enables / disables the addon",
							type = "toggle",
							width = "full",
							order = 5,
							get = function(info) return not MB.db.profile.premacroc[3] end,
							set = function(info, val) MB.db.profile.premacroc[3] = not MB.db.profile.premacroc[3] MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false)	end,
						},
						macrom3 = {
							type = "input",
							name = "MercenaryBuddy3",
							disabled = function() return MB.db.profile.premacroc[3] end,
							order = 6,
							width = "full",
							multiline = 6,
							get = function(info) return MB.db.profile.premacrom[3] end,
							set = function(info, value) MB.db.profile.premacrom[3] = value MB:UpdateMacro(true, MB.db.profile.showInfoUpdate, false) end,
						},
					},
				},
			},
		},
		priority ={
			type = "group",
			name = L["Prioritize Racials"],
			order = 3,
			args = { 
				worgen = {
					type = "header",
					name = L["Worgen"],
					order = 7,
				},
				worgenopt1 = {
					type = "select",
					values = function() return MB:SelectOption("Worgen") end,
					name = L["First"],
					order = 8,
					get = function(info) return MB:GetSelect("Worgen",1) end,
					set = function(info, value) MB:SetSelect("Worgen",1,value) end,
				},
				worgenopt2 = {
					type = "select",
					values = function() return MB:SelectOption("Worgen") end,
					name = L["Second"],
					order = 9,
					get = function(info) return MB:GetSelect("Worgen",2) end,
					set = function(info, value) MB:SetSelect("Worgen",2,value) end,
				},
				worgenopt3 = {
					type = "select",
					values = function() return MB:SelectOption("Worgen") end,
					name = L["Third"],
					order = 10,
					get = function(info) return MB:GetSelect("Worgen",3) end,
					set = function(info, value) MB:SetSelect("Worgen",3,value) end,
				},
				forsaken = {
					type = "header",
					name = L["Forsaken"],
					order = 0,
				},
				forsakenopt1 = {
					type = "select",
					values = function() return MB:SelectOption("Forsaken") end,
					name = L["First"],
					order = 1,
					get = function(info) return MB:GetSelect("Forsaken",1) end,
					set = function(info, value) MB:SetSelect("Forsaken",1,value) end,
				},
				forsakenopt2 = {
					type = "select",
					values = function() return MB:SelectOption("Forsaken") end,
					name = L["Second"],
					order = 2,
					get = function(info) return MB:GetSelect("Forsaken",2) end,
					set = function(info, value) MB:SetSelect("Forsaken",2,value) end,
				},
				goblin = {
					type = "header",
					name = L["Goblin"],
					order = 3,
				},
				goblinopt1 = {
					type = "select",
					values = function() return MB:SelectOption("Goblin") end,
					name = L["First"],
					order = 4,
					get = function(info) return MB:GetSelect("Goblin",1) end,
					set = function(info, value) MB:SetSelect("Goblin",1,value) end,
				},
				goblinopt2 = {
					type = "select",
					values = function() return MB:SelectOption("Goblin") end,
					name = L["Second"],
					order = 5,
					get = function(info) return MB:GetSelect("Goblin",2) end,
					set = function(info, value) MB:SetSelect("Goblin",2,value) end,
				},
				goblinopt3 = {
					type = "select",
					values = function() return MB:SelectOption("Goblin") end,
					name = L["Third"],
					order = 6,
					get = function(info) return MB:GetSelect("Goblin",3) end,
					set = function(info, value) MB:SetSelect("Goblin",3,value) end,
				},

			},
		},
		bugreport = {
			type = "group",
			name = L["Bug Report"],
			args = {
				bugreport = {
					type = "description",
					name = L["Report Usage"],
					fontSize = "medium",
				},
			},
		},
	},
}

function MB:GetSelect(race,index)
	for i = 1, 3 do
		if listracial[race][i] == MB.db.profile.racialorder[race][index] then
			return i
		end
	end
end

function MB:SetSelect(race,index,value)
	for i = 1, 3 do
		if listracial[race][value]	== MB.db.profile.racialorder[race][i] then
			MB.db.profile.racialorder[race][i], MB.db.profile.racialorder[race][index] = MB.db.profile.racialorder[race][index], MB.db.profile.racialorder[race][i]	
		end
	end
	MB:UpdateMacro(true, false, false)
end

function MB:SelectOption(index)
	local list = {}
	for i = 1, 3 do
		list[i] = listracial[index][i]
	end
	return list
end

-- function MB:MacroTemplate()
	-- print(MB.db.profile.premacro[1])
	-- local macro = MB.db.profile.premacro[1]
	-- macro = macro:gsub("%$racial","/RazzialeQui")
	-- print(macro)
	-- local index = GetMacroIndexByName("Testus")
	-- EditMacro(index, nil, nil, macro)
-- end

function MB:GetInfoUpdate(info)
	return self.db.profile.showInfoUpdate
end

function MB:SetInfoUpdate(info, value)
	self.db.profile.showInfoUpdate = value
end

-- Initialize

function MB:OnInitialize()
	-- Register the option tables
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Mercenary Buddy", options, "/mercenarybuddy")
	-- Create option UI
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Mercenary Buddy", "Mercenary Buddy")
	-- Command to open options
	local optF = self.optionsFrame
	self:RegisterChatCommand("mercenarybuddy", function() InterfaceOptionsFrame_OpenToCategory(optF) end)
	-- Manage saved variables
	self.db = LibStub("AceDB-3.0"):New("MercenaryBuddy", defaults)
	
	--self.chardb = LibStub("AceDB-3.0"):New("MercenaryBuddy", chardefaults)
	-- Register /racials to force update and /mercenary to print if mercenary spellID is found
	--self:RegisterChatCommand("racials", "UpdateMacro", true)
	--self:RegisterChatCommand("mercenary", "IsMercenary")
	--self:RegisterChatCommand("macrotemplate", "MacroTemplate")
	
	self:Print("version "..AddonVersion)
end

function MB:OnEnable()
	-- Register events that can make player a mercenary, Ashran and Battlegrounds
	self:RegisterEvent("BATTLEFIELD_MGR_ENTERED", "PreEnterBF")
	-- Delay further actions to complete ui load
	self:RegisterEvent("LOADING_SCREEN_DISABLED", "Loading")
end

function MB:Loading()
	self:UnregisterEvent("LOADING_SCREEN_DISABLED")
	self:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND", "PreEnterBG") -- Register here to avoid being called when already in Battlegrounds
	local _,_,_,_,_,_,_,zone = GetInstanceInfo()
	if MB:IsMercenary() then
		if zone==1191 then -- Check if the player reloaded ui inside ashran
			--print("In Ashran")
			MB:EnterBF(true)
			return
		elseif UnitInBattleground("player") ~= nil then
			--print("In Battleground")
			MB:EnterBG(true)
			return
		end
	end
	-- Update racial macros at character login
	MB:UpdateMacro(true, self.db.profile.showInfoUpdate, true)

end


-- Handlers for Battlegrounds


function MB:PreEnterBG()
	if UnitInBattleground("player") == nil then -- Check if called on reload ui inside a battleground
	--print("Pre Enter BG")
		--print("UnitInBattleground no")
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "EnterBG")
	end
end

function MB:EnterBG(forced)
	--print("Enter BG")
	if not forced then
		self:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
		self:RegisterEvent("LOADING_SCREEN_DISABLED", "EnterBG", true)
		return
	end
	self:UnregisterEvent("LOADING_SCREEN_DISABLED")
	if MB:IsMercenary() then
		self:RegisterEvent("PLAYER_LEAVING_WORLD", "PreLeaveBG")
		WasMercenary = true
		MB:UpdateMacro(false, self.db.profile.showInfoUpdate, WasMercenary, true)
	else
		WasMercenary = false
	end
end

function MB:PreLeaveBG()
	--print("Pre Leave BG")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "LeaveBG")
end

function MB:LeaveBG()
	--print("Leave BG")
	self:UnregisterEvent("PLAYER_LEAVING_WORLD")
	--self:UnregisterBucket(BucketHandlerBG)
	--BucketHandlerBG = nil
	MB:UpdateMacro(false, self.db.profile.showInfoUpdate, WasMercenary)
end


-- Handlers for Ashran


function MB:PreEnterBF()
	local _,_,_,_,_,_,_,zone = GetInstanceInfo()
	if zone==1191 then -- Check if the player entered ashran as him/her faction and got insta-enter
		MB:EnterBF(true)
		return
	end
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "EnterBF" )
end

function MB:EnterBF(forced)
	--print("Enter BF")
	if not forced then
		self:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
		self:RegisterEvent("LOADING_SCREEN_DISABLED", "EnterBF", true)
		return
	end
	self:UnregisterEvent("LOADING_SCREEN_DISABLED")
	--print("MB:IsMercenary() "..tostring(MB:IsMercenary()))
	if MB:IsMercenary() then
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "PreLeaveBF", 4)
		self:RegisterEvent("BATTLEFIELD_MGR_DROP_TIMER_STARTED", "PreLeaveBF", 2)
		self:RegisterEvent("BATTLEFIELD_MGR_EJECTED", "PreLeaveBF", 1)
		
		EventCountdown = 6 --Sum of events, when reach 0 in LeaveBF UpdateMacro() is called
		
		WasMercenary = true
		MB:UpdateMacro(false, self.db.profile.showInfoUpdate, WasMercenary, true)
	else
		WasMercenary = false
	end
end

function MB:ReEnterBF()
	self:UnregisterEvent("BATTLEFIELD_MGR_DROP_TIMER_CANCELED")
	MB:EnterBF(true)
end

function MB:PreLeaveBF(idEvent)
	--print("Leave BF WasMercenary "..tostring(WasMercenary))
	if idEvent == 4 then
		--print("UnregisterEvent(ZONE_CHANGED_NEW_AREA)")
		self:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
		EventCountdown = EventCountdown - idEvent
	elseif idEvent == 2 then
		--print("UnregisterEvent(BATTLEFIELD_MGR_DROP_TIMER_STARTED)")
		self:UnregisterEvent("BATTLEFIELD_MGR_DROP_TIMER_STARTED")
		self:RegisterEvent("LANGUAGE_LIST_CHANGED", "LeaveBF")
		self:RegisterEvent("BATTLEFIELD_MGR_DROP_TIMER_CANCELED", "ReEnterBF")
		EventCountdown = EventCountdown - idEvent	
		MB:UpdateMacro(false, self.db.profile.showInfoUpdate, WasMercenary)
	elseif idEvent == 1 then
		--print("UnregisterEvent(BATTLEFIELD_MGR_EJECTED)")
		self:UnregisterEvent("BATTLEFIELD_MGR_EJECTED")
		self:UnregisterEvent("BATTLEFIELD_MGR_DROP_TIMER_CANCELED")
		self:UnregisterEvent("LANGUAGE_LIST_CHANGED")
		EventCountdown = EventCountdown - idEvent	
	end
end

function MB:LeaveBF()
	self:UnregisterEvent("LANGUAGE_LIST_CHANGED")
	MB:UpdateMacro(false, self.db.profile.showInfoUpdate, WasMercenary)
end


-- Other Functions


function MB:InitMacro()
	local macro = {}
	local c = 1
	for i = 1,3 do
		local index = GetMacroIndexByName("MercenaryBuddy"..i)
		--print(index)
		if index == 0 then
			local _ = CreateMacro("MercenaryBuddy".. i, "INV_MISC_QUESTIONMARK", " ")
			macro[c] = i
			c = c+1
			--print("MK Mercenary Buddy".. i)
		end
	end
	MB:UpdateMacro(true)
	local msg = L["Created Macro"]
	for key, value in ipairs(macro) do
		msg = msg.." MercenaryBuddy"..value
	end
	if c== 1 then
		self:Print(L["Macro already created"])
	else
		self:Print(msg)
	end
end

function MB:DeleteMacro()
	for i = 1,3 do
		local index = GetMacroIndexByName("MercenaryBuddy"..i)
		--print(index)
		if index > 0 then
			local _ = DeleteMacro(index)
			--print("RM Mercenary Buddy".. i)
		end
	end
	--MB:UpdateMacro()
	self:Print(L["Deleted Macro"])
end

function MB:ResetCustomMacro()
	for i = 1,3 do
		MB.db.profile.premacro[i] = defaults.profile.premacro[i]
		MB.db.profile.premacrom[i] = defaults.profile.premacrom[i]
	end
	self:Print(L["Custom Macro reset to defaults"])
	MB:UpdateMacro(true, false, false)
end

function MB:LeavesCombat(forced, info, mercenary, entering)
	--print("LeavesCombat")
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	MB:UpdateMacro(forced, info, mercenary, entering)
end

function MB:IsMercenary()
	local mercenary=false
	for i=1,40 do 
		local _,_,_,_,_,_,_,_,_,_,spellID=UnitAura("player",i) 
		if spellID == 193864 or spellID == 193863 then 
			mercenary = true
			WasMercenary = true
		break 
		end 
	end
	--print("IsMercenary "..tostring(mercenary))
	return mercenary
end

function MB:UpdateMacro(forced, info, mercenary, entering)
	if not forced and not mercenary then
		--print("not forced and was not mercenary")
		return
	end
	
	if InCombatLockdown() then
		self:RegisterEvent("PLAYER_REGEN_ENABLED", "LeavesCombat", forced, info, mercenary, entering)
		self:Print(L["You are in combat, Racials update delayed until out of combat"])
		return
	end
	
	if not forced then
		if mercenary == false then
			return
		elseif mercenary == nil and info == nil then
			mercenary = true
			info = true
		end
	elseif info == nil then
		info = true
	end
	--print("info "..tostring(info))
	
	local name, rank, spellID
	local _, _, _, numSpells = GetSpellTabInfo(1)
	local racials = {}
	racials[1] = { 1, 2, 3}
	racials[2] = {}
	local c = 1
	
	for i=1,numSpells do
		name, rank, _, _, _, _, spellID = GetSpellInfo(i, "spell")
		if rank == L["Racial"] and GetSpellAvailableLevel(name) == 0 then
		--if rank == "Racial" then
			--print(GetSpellAvailableLevel(name))
			racials[2][c] = name
			c = c+1
			--print(name .." ".. rank.." "..spellID)
		end
	end
	
	local msg = L["New Racials"]
		for i = 1,3 do
		local index = GetMacroIndexByName("MercenaryBuddy"..i)
		--print(index)
		if index > 0 then
			EditMacro(index, nil, nil, "")
		end
	end
	
	racials = MB:Prioritize(racials)
	
	racials = MB:Sort(racials)
	
	for key, value in ipairs(racials[2]) do
		local index = GetMacroIndexByName("MercenaryBuddy"..key)
		--EditMacro(index, nil, nil, "#showtooltip\n/cast ".. value .."(Racial)")
		--local spellName = "/cast ".. value .."(Racial)"
		local macro 
		--print(entering)
		--print(MB:IsMercenary())
		--print(not MB.db.profile.premacroc[key])
		if((entering or MB:IsMercenary()) and not MB.db.profile.premacroc[key]) then
			macro = MB.db.profile.premacrom[key]
		else
			macro = MB.db.profile.premacro[key]
		end
		macro = macro:gsub("%$racial", value)
		
		EditMacro(index, nil, nil, macro)
		msg = msg.." "..key..":"..GetSpellLink(value)
		--print(key .." ".. value .." ".. racials[1][key])
	end
	
	if info then
		self:Print(L["Macro Updated"])
		if mercenary then
			self:Print(msg)
		end
	end
end

function MB:Prioritize(array) 
	for key, value in ipairs(array[2]) do
		for ikey, ivalue in ipairs(MB.db.profile.racialorder["Worgen"]) do
			local found = false
			if value == ivalue then
				--print("priorità")
				--print(racials[1][key])
				--print(ikey)
				array[1][key] = ikey
			end
			if found then
				return array
			end
		end
		for ikey, ivalue in ipairs(MB.db.profile.racialorder["Forsaken"]) do
			local found = false
			if value == ivalue then
				--print("priorità")
				--print(racials[1][key])
				--print(ikey)
				array[1][key] = ikey
			end
			if found then
				return array
			end
		end
		for ikey, ivalue in ipairs(MB.db.profile.racialorder["Goblin"]) do
			if value == ivalue then
				--print("priorità")
				--print(racials[1][key])
				--print(ikey)
				array[1][key] = ikey
			end
		end
	end
	return array
end

function MB:Sort(array) -- Bubblesort
	local changed
	repeat
    changed = false
	for key, value in ipairs(array[2]) do
		if array[1][key + 1] ~= nil then
			if array[1][key] > array[1][key + 1] then
				array[1][key], array[1][key + 1] = array[1][key + 1], array[1][key]
				array[2][key], array[2][key + 1] = array[2][key + 1], array[2][key]
				changed = true
				--print("changed")
			end
		end
	end
	until changed == false
	return array
end